# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


# This is the initialization for the Mmtrix Ruby Agent when used as
# a plugin
require 'mmtrix/control'

# If you are having problems seeing data, be sure and check the
# mmtrix_agent.log files in the log directory of your application
#
# If you can't find any log files and you don't see anything in your
# application log files please visit support.mmtrix.com.

# Initializer for the Mmtrix Ruby Agent

# After verison 2.0 of Rails we can access the configuration directly.
# We need it to add dev mode routes after initialization finished.

begin

  current_config = if defined?(config)
    config
  elsif defined?(Rails.configuration)
    Rails.configuration
  end

  Mmtrix::Control.instance.init_plugin :config => current_config

rescue => e
  ::Mmtrix::Agent.logger.error "Error initializing Mmtrix plugin. Agent is disabled.", e
end
