# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


module Mmtrix
  module Agent
    module Deprecator
      def self.deprecate(method_name, new_method_name = nil, version = nil)
        msgs = ["The method #{method_name} is deprecated."]
        msgs << "It will be removed in version #{version}." if version
        msgs << "Please use #{new_method_name} instead." if new_method_name

        Mmtrix::Agent.logger.log_once(:warn, "deprecated_#{method_name}".to_sym, msgs)
        Mmtrix::Agent.record_metric("Supportability/Deprecated/#{method_name}", 1)
      end
    end
  end
end
