# encoding: utf-8
# This file is distributed under Mmtrix's license terms.

require 'mmtrix/agent/instrumentation/active_record_subscriber'

DependencyDetection.defer do
  named :active_record_4

  depends_on do
    defined?(::ActiveRecord) && defined?(::ActiveRecord::Base) &&
      defined?(::ActiveRecord::VERSION) &&
      ::ActiveRecord::VERSION::MAJOR.to_i >= 4
  end

  depends_on do
    !Mmtrix::Agent.config[:disable_activerecord_instrumentation] &&
      !Mmtrix::Agent::Instrumentation::ActiveRecordSubscriber.subscribed?
  end

  executes do
    ::Mmtrix::Agent.logger.info 'Installing ActiveRecord 4 instrumentation'
  end

  executes do
    ActiveSupport::Notifications.subscribe('sql.active_record',
      Mmtrix::Agent::Instrumentation::ActiveRecordSubscriber.new)
    ::Mmtrix::Agent::Instrumentation::ActiveRecordHelper.instrument_writer_methods
  end
end
