# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


module ::Excon
  class Connection
    def mmtrix_connection_params
      (@connection || @data)
    end

    def mmtrix_resolved_request_params(request_params)
      resolved = mmtrix_connection_params.merge(request_params)
      resolved[:headers] = resolved[:headers].merge(request_params[:headers] || {})
      resolved
    end

    def request_with_mmtrix_trace(params, &block)
      orig_response = nil
      resolved_params = mmtrix_resolved_request_params(params)
      wrapped_request = ::Mmtrix::Agent::HTTPClients::ExconHTTPRequest.new(resolved_params)
      ::Mmtrix::Agent::CrossAppTracing.tl_trace_http_request(wrapped_request) do
        orig_response = request_without_mmtrix_trace(resolved_params, &block)
        ::Mmtrix::Agent::HTTPClients::ExconHTTPResponse.new(orig_response)
      end
      orig_response
    end

    def self.install_mmtrix_instrumentation
      alias request_without_mmtrix_trace request
      alias request request_with_mmtrix_trace
    end
  end
end
