# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'set'

DependencyDetection.defer do
  @name = :merb_controller

  depends_on do
    defined?(Merb) && defined?(Merb::Controller)
  end

  executes do
    ::Mmtrix::Agent.logger.info 'Installing Merb Controller instrumentation'
  end

  executes do
    require 'merb-core/controller/merb_controller'

    Merb::Controller.class_eval do
      include Mmtrix::Agent::Instrumentation::ControllerInstrumentation

      # determine the path that is used in the metric name for
      # the called controller action
      def mmtrix_metric_path
        "#{controller_name}/#{action_name}"
      end

      protected

      def _dispatch_with_mmtrix_trace(*args)
        options = {}
        options[:params] = params
        perform_action_with_mmtrix_trace(options) do
          _dispatch_without_mmtrix_trace(*args)
        end
      end

      alias_method :_dispatch_without_mmtrix_trace, :_dispatch
      alias_method :_dispatch, :_dispatch_with_mmtrix_trace
    end
  end
end
