# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


DependencyDetection.defer do
  named :net_http

  depends_on do
    defined?(Net) && defined?(Net::HTTP)
  end

  executes do
    ::Mmtrix::Agent.logger.info 'Installing Net instrumentation'
    require 'mmtrix/agent/cross_app_tracing'
    require 'mmtrix/agent/http_clients/net_http_wrappers'
  end

  executes do
    class Net::HTTP
      def request_with_mmtrix_trace(request, *args, &block)
        wrapped_request = Mmtrix::Agent::HTTPClients::NetHTTPRequest.new(self, request)

        Mmtrix::Agent::CrossAppTracing.tl_trace_http_request( wrapped_request ) do
          # RUBY-1244 Disable further tracing in request to avoid double
          # counting if connection wasn't started (which calls request again).
          Mmtrix::Agent.disable_all_tracing do
            request_without_mmtrix_trace( request, *args, &block )
          end
        end
      end

      alias request_without_mmtrix_trace request
      alias request request_with_mmtrix_trace
    end
  end
end
