# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


module Mmtrix
  module Agent
    module Instrumentation
      module Rails3
        module Errors

          # @api public
          # @deprecated
          def mmtrix_notice_error(exception, custom_params = {})
            Mmtrix::Agent::Deprecator.deprecate("ActionController#mmtrix_notice_error",
                                                  "Mmtrix::Agent#notice_error")

            Mmtrix::Agent::Transaction.notice_error(exception,
                                                      :metric => mmtrix_metric_path,
                                                      :custom_params => custom_params)
          end
        end
      end
    end
  end
end

DependencyDetection.defer do
  @name = :rails3_error

  depends_on do
    defined?(::Rails) && ::Rails::VERSION::MAJOR.to_i == 3
  end

  depends_on do
    defined?(ActionController) && defined?(ActionController::Base)
  end

  executes do
    ::Mmtrix::Agent.logger.info 'Installing Rails 3 Error instrumentation'
  end

  executes do
    class ActionController::Base
      include Mmtrix::Agent::Instrumentation::Rails3::Errors
    end
  end
end
