# encoding: utf-8
# This file is distributed under Mmtrix's license terms.

require 'mmtrix/agent/instrumentation/action_controller_subscriber'


DependencyDetection.defer do
  @name = :rails4_controller

  depends_on do
    defined?(::Rails) && ::Rails::VERSION::MAJOR.to_i == 4
  end

  depends_on do
    defined?(ActionController) && defined?(ActionController::Base)
  end

  executes do
    ::Mmtrix::Agent.logger.info 'Installing Rails 4 Controller instrumentation'
  end

  executes do
    class ActionController::Base
      include Mmtrix::Agent::Instrumentation::ControllerInstrumentation
    end
    Mmtrix::Agent::Instrumentation::ActionControllerSubscriber \
      .subscribe(/^process_action.action_controller$/)
  end
end
