# encoding: utf-8
# This file is distributed under Mmtrix's license terms.

require 'mmtrix/agent/instrumentation/action_view_subscriber'

DependencyDetection.defer do
  @name = :rails4_view

  depends_on do
    defined?(::Rails) && ::Rails::VERSION::MAJOR.to_i == 4
  end

  depends_on do
    !Mmtrix::Agent.config[:disable_view_instrumentation] &&
      !Mmtrix::Agent::Instrumentation::ActionViewSubscriber.subscribed?
  end

  executes do
    ::Mmtrix::Agent.logger.info 'Installing Rails 4 view instrumentation'
  end

  executes do
    Mmtrix::Agent::Instrumentation::ActionViewSubscriber.subscribe(/render_.+\.action_view$/)
  end
end
