# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


DependencyDetection.defer do
  named :rubyprof

  depends_on do
    defined?(::RubyProf) && defined?(::Mmtrix::Rack::DeveloperMode) && ::Mmtrix::Agent.config[:developer_mode]
  end

  executes do
    Mmtrix::Agent.instance.events.subscribe(:start_transaction) do
      if Mmtrix::Rack::DeveloperMode.profiling_enabled?
        ::RubyProf.start
      end
    end

    Mmtrix::Agent.instance.events.subscribe(:transaction_finished) do
      if Mmtrix::Rack::DeveloperMode.profiling_enabled?
        trace = Mmtrix::Agent::Transaction.tl_current.transaction_trace
        trace.profile = ::RubyProf.stop
      end
    end
  end
end
