# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'base64'
require 'zlib'

module Mmtrix
  module Agent
    class MmtrixService
      module Encoders
        module Identity
          def self.encode(data, opts=nil)
            data
          end
        end

        module Compressed
          def self.encode(data, opts=nil)
            Zlib::Deflate.deflate(data, Zlib::DEFAULT_COMPRESSION)
          end
        end

        module Base64CompressedJSON
          def self.encode(data, opts={})
            normalize_encodings = if opts[:skip_normalization]
              false
            else
              Agent.config[:normalize_json_string_encodings]
            end
            json = ::Mmtrix::JSONWrapper.dump(data, :normalize => normalize_encodings)
            Base64.encode64(Compressed.encode(json))
          end
        end
      end
    end
  end
end
