# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'mmtrix/agent/sampler'

module Mmtrix
  module Agent
    module Samplers
      class ObjectSampler < Mmtrix::Agent::Sampler
        named :object

        def self.supported_on_this_platform?
          Mmtrix::LanguageSupport.object_space_usable? && ObjectSpace.respond_to?(:live_objects)
        end

        def poll
          live_objects = ObjectSpace.live_objects
          Mmtrix::Agent.record_metric("GC/objects", live_objects)
        end
      end
    end
  end
end
