# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'mmtrix/agent/stats_engine/metric_stats'
require 'mmtrix/agent/stats_engine/samplers'
require 'mmtrix/agent/stats_engine/gc_profiler'
require 'mmtrix/agent/stats_engine/stats_hash'

module Mmtrix
  module Agent
    # This class handles all the statistics gathering for the agent
    class StatsEngine
      include MetricStats
      include Samplers

      attr_accessor :metric_rules

      def initialize
        @stats_lock   = Mutex.new
        @stats_hash   = StatsHash.new
        @metric_rules = RulesEngine.new
      end

      # All access to the @stats_hash ivar should be funnelled through this
      # method to ensure thread-safety.
      def with_stats_lock
        @stats_lock.synchronize { yield }
      end
    end
  end
end
