# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'mmtrix/language_support'
require 'mmtrix/agent/vm/mri_vm'
require 'mmtrix/agent/vm/jruby_vm'
require 'mmtrix/agent/vm/rubinius_vm'

module Mmtrix
  module Agent
    module VM
      def self.snapshot
        vm.snapshot
      end

      def self.vm
        @vm ||= create_vm
      end

      def self.create_vm
        if Mmtrix::LanguageSupport.using_engine?('jruby')
          JRubyVM.new
        elsif Mmtrix::LanguageSupport.using_engine?('rbx')
          RubiniusVM.new
        else
          MriVM.new
        end
      end
    end
  end
end
