# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'yaml'
require 'conditional_vendored_dependency_detection'
require 'mmtrix/local_environment'
require 'mmtrix/language_support'
require 'mmtrix/helper'
require 'mmtrix/json_wrapper'

require 'singleton'
require 'erb'
require 'socket'
require 'net/https'
require 'logger'
require 'mmtrix/control/frameworks'
require 'mmtrix/control/server_methods'
require 'mmtrix/control/instrumentation'
require 'mmtrix/control/class_methods'
require 'mmtrix/control/instance_methods'

require 'mmtrix/agent'
require 'mmtrix/delayed_job_injection'

module Mmtrix

  # The Control is a singleton responsible for the startup and
  # initialization sequence.  The initializer uses a LocalEnvironment to
  # detect the framework and instantiates the framework specific
  # subclass.
  #
  # The Control also implements some of the public API for the agent.
  #
  class Control
    # done in a subfile for load order purposes
    # extend ClassMethods
    # include InstanceMethods
    # include Configuration
    # include ServerMethods
    # include Instrumentation
  end
end
